unit mpegfile;
{
****************************************************************
*       updates can be found at http://www.renatager.de        *
*                      done by tric                            *
*                                                              *
* ver. 1.1                                                     *
*                                                              *
* Please send me any changes/fixes/addings you make. I publish *
* this unit like something like open sources! ;)               *
*                                                              *
*                                                              *
* Last changed 06.07.2000 by tric                              *
* -fixed some stuff                                            *
* -also unknown lyricsv2 ids were read and written             *
*                                                              *
* Last changed 11.02.2000 by SiNnEr                            *
* -fixed all the Lyrics3 stuff                                 *
* -included Lyricstag in Ttag                                  *
* -FULL 100% Support for Lyrics3 in all Modules                *
*                                                              *
* Last changed 10.01.2000                                      *
* -fixed setlyrtag now writing really the lyrtag ;)<-not really ;) *
* -IND is set on writing if now one is on lyrtag               *
*                                                              *
* Last changed 16.12.1999                                      *
* -Added filename to Tagrec                                    *
* -Added anzahl to tlyrtag                                     *
*                                                              *
* Last changed 7.9.1999                                        *
* -Added Lyrics3v1+2 Tag read                                  *
* -Added Lyrics3v200 Tag write                                 *
*  I do not check if the tag is correct! But existing fields   *
*  won't be overwritten if they do not exist in the new tag    *
* Last changed 2.9.1999                                        *
* -Added ID3 Tag read&write                                    *
*                                                              *
****************************************************************
}

interface

uses SysUtils, WinTypes, WinProcs, Classes, Messages, Controls;

type
  TMPEGData = packed record
    Duration : word;         { Song duration }
    FileLength : LongInt;    { File length }
    Version : byte;          { MPEG audio version index (1 - Version 1,
                               2 - Version 2,  3 - Version 2.5,
                               0 - unknown }
    Layer : byte;            { Layer (1, 2, 3, 0 - unknown) }
    SampleRate : LongInt;    { Sampling rate in Hz}
    BitRate : LongInt;       { Bit Rate }
    Mode : byte;             { Number of channels (0 - Stereo,
                               1 - Joint-Stereo, 2 - Dual-channel,
                               3 - Single-Channel) }
    Copyright : Boolean;     { Copyrighted? }
    Original : Boolean;      { Original? }
    ErrorProtection : boolean; { Error protected? }
    Padding : Boolean;       { If frame is padded }
    FrameLength : Word;      { total frame size including CRC }
    CRC : word;              { 16 bit File CRC (without TAG).
                               Not implemented yet. }
    encoder : string;
  end;

{INF    99999   Additional information multi line text.
AUT    00250   Lyrics/Music Author name.
EAL    00250   Extended Album name.
EAR    00250   Extended Artist name.
ETT    00250   Extended Track Title.
IMG    99999   Link to an image files (BMP, JPG, GIF format).
LYR    99999   Lyrics multi line text. }

  Tfield  = record
             id:string[3];         //die ID
             size:string[5];       //wird zum schreiben nich bentigt
             data:string;          //die daten an sich
            end;
  TLyrtag = record
             field:array of tfield; //die daten
             anzahl:word;           //die anzahl der fields
             size:string[6];        //die lnge wird beim schreiben nich bentigt!
             ver:byte;              //0=ID3Tag 1=lyrtagv1 2=lyrtagv2
            end;
  Ttagrec = record
             datei     : string;
             song      : string;
             kuenstler : string;
             album     : string;
             kommentar :string;
             jahr      :string[4];
             track     :string[3];
             genre     :integer;
             info      :string;
             lyrics    :string;
             author    :string[250];
             images    :string;
             lyricsv2  :Tlyrtag; //lyricstagv2 id not known are saved here
             lyricstag :byte; {0=nur ID3Tag 1/1.1 - 1=Lyrics3Tagv1 - 2=Lyrics3Tagv2}
             id3v2     :byte; //(major version of id3v2 tag, 0 if none
            end;


const
  genremenge=148;
  transint2art:array[-1..genremenge] of string[25]=('-','Blues','Classic Rock',
  'Country','Dance','Disco','Funk','Grunge','Hip-Hop','Jazz','Metal','New Age','Oldies',
 'Other','Pop','R&B','Rap','Reggae','Rock','Techno','Industrial','Alternative','Ska',
 'Death Metal','Pranks',
 'Soundtrack','Euro-Techno','Ambient','Trip-Hop','Vocal','Jazz+Funk','Fusion','Trance',
 'Classical','Instrumental',
 'Acid','House','Game','Sound Clip','Gospel','Noise','AlternRock','Bass','Soul','Punk',
 'Space','Meditative',
 'Instrumental Pop','Instrumental Rock','Ethnic','Gothic','Darkwave','Techno-Industrial',
 'Electronic','Pop-Folk',
 'Eurodance','Dream','Southern Rock','Comedy','Cult','Gangsta','Top 40','Christian Rap',
 'Pop/Funk','Jungle',
 'Native American','Cabaret','New Wave','Psychedelic','Rave','Showtunes','Trailer','Lo-Fi',
 'Tribal','Acid Punk',
 'Acid Jazz','Polka','Retro','Musical','Rock & Roll','Hard Rock','Folk','Folk/Rock',
 'National Folk','Swing','Fast-Fusion','Bebob',
 'Latin','Revival','Celtic','Bluegrass','Avantgarde','Gothic Rock','Progressive Rock',
 'Psychedelic Rock','Symphonic Rock',
 'Slow Rock','Big Band','Chorus','Easy Listening','Acoustic','Humour','Speech','Chanson',
 'Opera','Chamber Music','Sonata',
 'Symphony','Booty Bass','Primus','Porn Groove','Satire','Slow Jam','Club','Tango',
 'Samba','Folklore','Ballad','Power Ballad','Rhythmic Soul','Freestyle','Duet','Punk Rock',
 'Drum Solo','A capella','Euro-House','Dance Hall','Goa','Drum & Bass','Club-House',
 'Hardcore','Terror','Indie','BritPop','Negerpunk','Polsk Punk','Beat','Christian Gangsta Rap',
 'Heavy Metal','Black Metal','Crossover','Contemporary Christian','Christian Rock',
 'Merengue','Salsa','Trash Metal','Anime','Jpop','Synthpop', '-');


const
  { MPEG version indexes }
  MPEG_VERSION_UNKNOWN = 0; { Unknown     }
  MPEG_VERSION_1 = 1;       { Version 1   }
  MPEG_VERSION_2 = 2;       { Version 2   }
  MPEG_VERSION_25 = 3;      { Version 2.5 }

  { Description of MPEG version index }
  MPEG_VERSIONS : array[0..3] of string = ('Unknown', '1.0', '2.0', '2.5');

  { Channel mode (number of channels) in MPEG file }
  MPEG_MD_STEREO = 0;            { Stereo }
  MPEG_MD_JOINT_STEREO = 1;      { Stereo }
  MPEG_MD_DUAL_CHANNEL = 2;      { Stereo }
  MPEG_MD_MONO = 3;              { Mono   }

  { Description of number of channels }
  MPEG_MODES : array[0..3] of string = ('Stereo', 'Joint-Stereo',
                                        'Dual-Channel', 'Single-Channel');

  { Description of layer value }
  MPEG_LAYERS : array[0..3] of string = ('Unknown', 'I', 'II', 'III');

  {
    Sampling rates table.
    You can read mpeg sampling frequency as
    MPEG_SAMPLE_RATES[mpeg_version_index][samplerate_index]
  }
  MPEG_SAMPLE_RATES : array[1..3] of array[0..3] of word =
     { Version 1   }
    ((44100, 48000, 32000, 0),
     { Version 2   }
     (22050, 24000, 16000, 0),
     { Version 2.5 }
     (11025, 12000, 8000, 0));

  {
    Predefined bitrate table.
    Right bitrate is MPEG_BIT_RATES[mpeg_version_index][layer][bitrate_index]
  }
  MPEG_BIT_RATES : array[1..3] of array[1..3] of array[0..15] of word =
       { Version 1, Layer I     }
     (((0,32,64,96,128,160,192,224,256,288,320,352,384,416,448,0),
       { Version 1, Layer II    }
       (0,32,48,56, 64, 80, 96,112,128,160,192,224,256,320,384,0),
       { Version 1, Layer III   }
       (0,32,40,48, 56, 64, 80, 96,112,128,160,192,224,256,320,0)),
       { Version 2, Layer I     }
      ((0,32,64,96,128,160,192,224,256,288,320,352,384,416,448,0),
       { Version 2, Layer II    }
       (0,32,48,56, 64, 80, 96,112,128,160,192,224,256,320,384,0),
       { Version 2, Layer III   }
       (0, 8,16,24, 32, 64, 80, 56, 64,128,160,112,128,256,320,0)),
       { Version 2.5, Layer I   }
      ((0,32,64,96,128,160,192,224,256,288,320,352,384,416,448,0),
       { Version 2.5, Layer II  }
       (0,32,48,56, 64, 80, 96,112,128,160,192,224,256,320,384,0),
       { Version 2.5, Layer III }
       (0, 8,16,24, 32, 64, 80, 56, 64,128,160,112,128,256,320,0)));

  { Types of MPEG AUDIO DATAFILE }
  MPEG_DF_CUSTOM = 0;
  MPEG_DF_CATALOGUE = 1;
  MPEG_DF_ORDER_FORM = 2;

  { Description of MPEG AUDIO DATAFILE type }
  MPEG_DATAFILE_TYPES : array[0..2] of string = ('Custom','Catalogue',
                                                 'Order form');

  { Sign for MPEG Audio Datafile. This is used in MPEG Audio Datafile
    header to identify file as such. First eight bytes (i.e #9'MP3DATA')
    are file id, and rest two bytes are version and subversion numbers.
    Do not change it. }
  MPEG_DATAFILE_SIGN : string[9] = 'MP3DATA'+#01+#02;

  { File types that unit can recognize and read }
  FT_UNKNOWN = 0;                { Unknown }
  FT_WINAMP_PLAYLIST = 1;        { WinAmp playlist (*.m3u) }
  FT_MPEG_DATAFILE = 2;          { MPEG Audio Datafile (*.m3d) }
  FT_MPEG_AUDIO = 3;             { MPEG Audio }


const noencoder:string='Encoder nicht erkannt';



function FReadData(var data:TMPEGData;filename:string) : Integer;
function readtag(datei:string;var tag:Ttagrec):boolean;
function HasAttr(const FileName: string; Attr: Word): Boolean;
function truncstr(s:string):string;
procedure writetag(datei:string;tag:Ttagrec;schreibschutz,uselyricstag:boolean);
procedure removetag(datei:string;schreibschutz:boolean);

implementation

function HasAttr(const FileName: string; Attr: Word): Boolean;
var
 FileAttr: Integer;
begin
  FileAttr := FileGetAttr(FileName);
  if FileAttr = -1 then FileAttr := 0;
  Result := (FileAttr and Attr) = Attr;
end;

function truncstr(s:string):string;
begin
 while (length(s)>0) and (s[length(s)] in [' ',#0]) do delete(s,length(s),1);
 result:=s;
end;

function fillempty(source:string;leng:word):string;
var i:word;
    s:string;
begin
 result:=source;
 if length(source)>leng then
  delete(result,leng+1,length(source)-leng)
  else for i:=length(source)+1 to leng do result:=result+#0;
  s:=result;
end;

procedure removetag(datei:string;schreibschutz:boolean);
var
    Attributes, NewAttributes: Word;
    f: file of Byte;
    Buf: array[1..128] of Char;
    size:LongInt;
begin
 if fileexists(datei) then
  begin
   assignfile(f,datei);
   Attributes := FileGetAttr(datei);
   if not schreibschutz then begin
      NewAttributes := Attributes;
      NewAttributes := NewAttributes and not faReadOnly;
      FileSetAttr(datei, NewAttributes);
   end;
   filemode:=2;
   Reset(f);
   seek(f,filesize(f)-128);
   blockread(f,buf,128);
   if copy(buf,1,3)='TAG' then begin
      seek(f,filesize(f)-128);
      truncate(f);
   end;
   seek(f,filesize(f)-9);
   blockread(f,buf,9);
   if (pos('LYRICSEND',buf)=1) then begin
      seek(f,filesize(f)-5237);
      truncate(f);
   end;
   if (pos('LYRICS200',buf)=1) then begin
      seek(f,filesize(f)-15);
      blockread(f,buf,6);
      size:=strtoint(copy(buf,1,6));
      seek(f,filesize(f)-15-size);
      truncate(f);
   end;
   closefile(f);
   if not schreibschutz then
      FileSetAttr(datei, Attributes);
  end;
end;

function readtag(datei:string;var tag:Ttagrec):boolean;
var  f      : file of byte;
     Buf    : array[1..99999] of Char;
     leng,c :integer;
     Fieldtype : String;
     Fieldsize : String;
     Fielddata : String;
begin
  result:=false;
  if fileexists(datei) then
  begin
    assignfile(f,datei);
    if not HasAttr(datei,fadirectory) then
    begin
      FileMode := 0;
      Reset(f);
      if filesize(f)>137 then
      begin
        blockread(f,buf,5);
        if (pos('ID3',buf)<>0) and (ord(buf[3])<>$FF) and (ord(buf[4])<>$FF) then
         begin
          tag.id3v2:=strtoint(buf[3]);
         end else tag.id3v2:=0;
        seek(f,filesize(f)-137);
        blockread(f,buf,137);
        tag.lyricstag:=0;
        if pos('TAG',buf)=10 then
        begin
          tag.song:=truncstr(copy(buf,13,30));
          tag.kuenstler:=truncstr(copy(buf,43,30));
          tag.album:=truncstr(copy(buf,73,30));
          tag.jahr:=truncstr(copy(buf,103,4));
          tag.kommentar:=truncstr(copy(buf,107,30));
          str(ord(buf[136]),tag.track);
          tag.genre:=ord(buf[137]);
          if (tag.genre>=genremenge) or (tag.genre<0)then tag.genre:=genremenge;
          tag.datei:=datei;
          result:=true;
//SINNER LYRICS3v1
          if pos('LYRICSEND',buf)=1 then
          begin
             tag.lyricstag:=1;
             seek(f, filesize(f)-5237);
             blockread(f,buf,5100);
             if pos('LYRICSBEGIN',buf)=1 then
                tag.lyrics:=copy(buf,11,5089);
          end;
//SINNER LYRICS3v2
          if pos('LYRICS200',buf)=1 then
          begin
             seek(f,filesize(f)-143);
             blockread(f,buf,6);
             val(copy(buf,1,6),leng,c);
             seek(f,filesize(f)-143-leng);
             blockread(f,buf,11);
             if copy(buf,1,11)='LYRICSBEGIN' then tag.lyricstag:=2 else tag.lyricstag:=0;
             if tag.lyricstag>0 then
              begin
             repeat
                Fieldtype:='';
                FieldData:='';
                FieldSize:='';
                blockread(f,buf,3);
                FieldType:=copy(buf,1,3);
                blockread(f,buf,5);
                FieldSize:=copy(buf,1,5);
                if StrToInt(fieldsize)=0 then
                 begin
                  tag.lyricstag:=0;
                  break;
                 end;
                blockread(f,buf,StrToInt(fieldsize));
                FieldData:=copy(buf,1,StrToInt(fieldsize));
                if not ((fieldtype='ETT') or (fieldtype='EAL') or (fieldtype='EAR') or
                        (fieldtype='INF') or (fieldtype='LYR') or (fieldtype='AUT')) then
                 begin    //id not known
                  setlength(tag.lyricsv2.field,length(tag.lyricsv2.field)+1);
                  tag.lyricsv2.field[length(tag.lyricsv2.field)-1].id:=fieldtype;
                  tag.lyricsv2.field[length(tag.lyricsv2.field)-1].data:=fielddata;
                  tag.lyricsv2.field[length(tag.lyricsv2.field)-1].size:=fieldsize;
                 end
                 else
                 begin
                  if FieldType = 'EAL' then tag.album:=fielddata;
                  if FieldType = 'EAR' then tag.kuenstler:=fielddata;
                  if FieldType = 'ETT' then tag.Song:=fielddata;
                  if FieldType = 'INF' then tag.info:=fielddata;
                  if FieldType = 'IMG' then tag.images:=fielddata;
                  if FieldType = 'AUT' then tag.author:=fielddata;
                 end
             until(FilePos(f) >= (FileSize(f)-143));
            end;
          end;
       end else
       begin
          tag.song:='';
          tag.kuenstler:='';
          tag.album:='';
          tag.jahr:='';
          tag.kommentar:='';
          tag.genre:=-1;
          tag.info:='';
          tag.author:='';
          tag.images:='';
          tag.lyrics:='';
          result:=false;
       end;
    end;
    closefile(f);
    end;
  end;
end;



procedure writetag(datei:string;tag:Ttagrec;schreibschutz,uselyricstag:boolean);
var
   Attributes, NewAttributes: Word;
   f: file of Byte;
   n,c:integer;
   buffer2: array[1..128] of char;
   s:string;
   l3buf: array[1..99999] of char;
   l3length : LongInt;
function writelyric(text,tag:string):integer;
var s:string;
    ftag:string[3];
    n:integer;
    l3buf: array[1..99999] of char;
begin
 ftag:=tag;
 s:=ftag+FormatFloat('00000',length(text));
 for n := 1 to 8 do l3buf[n]:=s[n];
 blockwrite(f,l3buf,8);
 for n := 1 to length(text) do l3buf[n]:=text[n];
 blockwrite(f,l3buf,length(text));
 result:=8+length(text);
end;
begin
   removetag(datei,schreibschutz);
   if uselyricstag then begin
     if (length(tag.song)>30) or
        (length(tag.album)>30) or
        (length(tag.info)>0) or
        (length(tag.lyrics)>0) or
        (length(tag.author)>0) or
        (length(tag.images)>0) or
        (length(tag.kuenstler)>30) then
   begin
     assignfile(f, datei);
     Attributes := FileGetAttr(datei);
     if not schreibschutz then begin
        NewAttributes := Attributes;
        NewAttributes := NewAttributes and not faReadOnly;
        FileSetAttr(datei, NewAttributes);
     end;
     filemode:=2;
     Reset(f);
     seek(f, filesize(f));
     for n:=1 to 19 do l3buf[n]:='LYRICSBEGININD00002'[n];
     if tag.lyrics<>'' then
      begin
       l3buf[20]:='1';
       l3buf[21]:='1';
      end else
      begin
       l3buf[20]:='0';
       l3buf[21]:='0';
      end;
     blockwrite(f,l3buf,21);
     l3length:=21;
//AUT
     if length(tag.author) > 0 then
      begin
       l3length:=l3length+writelyric(tag.author,'AUT');
      end;
//IMG
     if length(tag.images) > 0 then
      begin
       l3length:=l3length+writelyric(tag.images,'IMG');
      end;
//LYR
     if length(tag.lyrics) > 0 then
      begin
       l3length:=l3length+writelyric(tag.lyrics,'LYR');
      end;
//INF
     if length(tag.info) > 0 then
      begin
       l3length:=l3length+writelyric(tag.info,'INF');
      end;
//ETT
     if length(tag.song) > 30 then
      begin
       l3length:=l3length+writelyric(tag.song,'ETT');
      end;

//EAR
     if length(tag.kuenstler) > 30 then
      begin
       l3length:=l3length+writelyric(tag.kuenstler,'EAR');
      end;

//EAL
     if length(tag.album) > 30 then
      begin
       l3length:=l3length+writelyric(tag.album,'EAL');
      end;
//other id not known
     if length(tag.lyricsv2.field)>0 then
      begin
       for n:=0 to length(tag.lyricsv2.field) do
        if not ((tag.lyricsv2.field[n].id='ETT') or (tag.lyricsv2.field[n].id='EAL')
                 or (tag.lyricsv2.field[n].id='EAR') or
                (tag.lyricsv2.field[n].id='INF') or (tag.lyricsv2.field[n].id='LYR')
                 or (tag.lyricsv2.field[n].id='AUT')) then
         l3length:=l3length+writelyric(tag.lyricsv2.field[n].data,tag.lyricsv2.field[n].id);
      end;
     s:=formatfloat('000000', l3length)+'LYRICS200';
     for n := 1 to 15 do l3buf[n]:=s[n];
     blockwrite(f,l3buf,15);
     closefile(f);
     end;
   end;
//ENDE LYRICS3TAGv2
//START ID3TAG
     for n:=1 to 3 do buffer2[n]:='TAG'[n];
     s:=fillempty(tag.song,30);
     for n:=4 to 33 do buffer2[n]:=s[n-3];
     s:=fillempty(tag.kuenstler,30);
     for n:=34 to 63 do buffer2[n]:=s[n-33];
     s:=fillempty(tag.album,30);
     for n:=64 to 93 do buffer2[n]:=s[n-63];
     s:=fillempty(tag.jahr,4);
     for n:=94 to 97 do buffer2[n]:=s[n-93];
     s:=fillempty(tag.kommentar,30);
     for n:=98 to 127 do buffer2[n]:=s[n-97];
     if tag.track<>'' then
      begin
       val(tag.track,n,c);
       if c=0 then buffer2[127]:=chr(n);
      end;
     buffer2[128]:=chr(tag.genre);
     assignfile(f,datei);
     Attributes := FileGetAttr(datei);
     if not schreibschutz then
      begin
       NewAttributes := Attributes;
       NewAttributes := NewAttributes and not faReadOnly;
       FileSetAttr(datei, NewAttributes);
      end;
     filemode:=2;
     Reset(f);
     seek(f,filesize(f));
     blockwrite(f,buffer2,128);
     closefile(f);
     if not schreibschutz then
       FileSetAttr(datei, Attributes);
end;

function CalcFrameLength (SampleRate, BitRate : LongInt; Padding : Boolean) : Integer;
begin
  If SampleRate > 0 then
    Result := Trunc (144 * BitRate * 1000 / SampleRate + Integer (Padding))
  else Result := 0;
end;


function FrameHeaderValid (Data : TMPEGData) : Boolean;
begin
    Result := (Data.Version > 0) and
              (Data.Layer > 0) and
              (Data.BitRate > 0) and (Data.SampleRate > 0);
end;


function DecodeHeader (MPEGHeader : LongInt; var MPEGData : TMpegData) : Boolean;
  { Decode MPEG Frame Header and store data to TMPEGData fields.
    Return True if header seems valid }
var
  BitrateIndex : byte;
  VersionIndex : byte;
  bolsche:boolean;

begin
  MPEGData.Version := 0;
  MPEGData.Layer := 0;
  MPEGData.SampleRate := 0;
  MPEGData.Mode := 0;
  MPEGData.Copyright := False;
  MPEGData.Original := False;
  MPEGData.ErrorProtection := False;
  MPEGData.Padding := False;
  MPEGData.BitRate := 0;
  MPEGData.FrameLength := 0;
  If (MPEGHeader and $ffe00000) = $ffe00000 then begin
    VersionIndex := (MPEGHeader shr 19) and $3;
    case VersionIndex of
      0 : MPEGData.Version := MPEG_VERSION_25;      { Version 2.5 }
      1 : MPEGData.Version := MPEG_VERSION_UNKNOWN; { Unknown }
      2 : MPEGData.Version := MPEG_VERSION_2;       { Version 2 }
      3 : MPEGData.Version := MPEG_VERSION_1;       { Version 1 }
    end;
    { if Version is known, read other data }
    If MPEGData.Version <> MPEG_VERSION_UNKNOWN then begin
      MPEGData.Layer := 4 - ((MPEGHeader shr 17) and $3);
      If (MPEGData.Layer > 3) then MPEGData.Layer := 0;

      BitrateIndex := ((MPEGHeader shr 12) and $F);
      MPEGData.SampleRate := MPEG_SAMPLE_RATES[MPEGData.Version][((MPEGHeader shr 10) and $3)];
      MPEGData.ErrorProtection := ((MPEGHeader shr 16) and $1) = 1;
      MPEGData.Copyright := ((MPEGHeader shr 3) and $1) = 1;
      MPEGData.Original := ((MPEGHeader shr 2) and $1) = 1;
      MPEGData.Mode := ((MPEGHeader shr 6) and $3);
      MPEGData.Padding := ((MPEGHeader shr 9) and $1) = 1;
      bolsche:=(MPEGData.Version in [1..3]) and (MPEGData.Layer in [1..3]) and (BitrateIndex in [0..15]);
      if bolsche then
       begin
        MPEGData.BitRate := MPEG_BIT_RATES[MPEGData.Version][MPEGData.Layer][BitrateIndex];
       end;
      If MPEGData.BitRate = 0 then MPEGData.Duration := 0
      else MPEGData.Duration := (MPEGData.FileLength*8) div (longint(MPEGData.Bitrate)*1000);
      MPEGData.FRameLength := CalcFrameLength (MPEGData.SampleRate, MPEGData.BitRate, MPEGData.Padding);
    end;
    Result := FrameHeaderValid (MPEGData);
  end else Result := False;
end;


procedure ResetData(var data:TMPEGData);
{ Empty MPEG data }
const
  Notag = '[notag]';
begin
  with Data do begin
    Duration := 0;
    FileLength := 0;
    Version := 0;
    Layer := 0;
    SampleRate := 0;
    Mode := 0;
    Copyright := False;
    Original := False;
    ErrorProtection := False;
    Padding := False;
    FrameLength := 0;
    BitRate := 0;
    CRC := 0;
    encoder:=noencoder;
  end; { with }
end; { function }


function FReadData(var data:TMPEGData;filename:string) : Integer;
var
  mpfile:file;
  mp3hdrread : array[1..8] of byte;
  mp3hdr : LongInt ABSOLUTE mp3hdrread;
  tempbyte : byte;
  frames,tempLongInt : LongInt;
  FFirstValidFrameHeaderPosition : LongInt;
  FFileDetectionPrecision : Integer;
  buffer:array[1..256] of char;

begin
  Result := -1;
  ResetData(data);
  if fileexists(filename) then
   begin
    assignfile(mpfile,filename);
    FileMode := 0;
    {$I-}
    Reset (mpfile,1);
    {$I+}
    Result := IOResult;
    if (Result=0) and (FileSize(mpfile) > 5) then begin
{      Data.FileDateTime := FileAge (fileName);
      Data.FileAttr := FileGetAttr (FileName);}
      Data.FileLength := FileSize (mpfile);

      repeat
        { read MPEG header from file }
        BlockRead (mpfile, mp3hdrread,4);
        tempbyte := mp3hdrread[1];
        mp3hdrread[1] := mp3hdrread[4];
        mp3hdrread[4] := tempbyte;
        tempbyte := mp3hdrread[2];
        mp3hdrread[2] := mp3hdrread[3];
        mp3hdrread[3] := tempbyte;
        FFileDetectionPRecision:=0;
        While (not DecodeHeader (mp3hdr, Data)) and (not Eof (mpfile)) and
              ((FilePos(mpfile) <= FFileDetectionPrecision)
              or (FFileDetectionPRecision = 0))
        do begin
          { if mpeg header is not at the begining of the file, search file
            to find proper frame sync. This block can be speed up by reading
            blocks of bytes instead reading single byte from file }
           mp3hdr := mp3hdr shl 8;
           BlockRead (mpfile, tempbyte,1);
           mp3hdrread[1] := tempbyte;

        end; { while }

        FFirstValidFrameHeaderPosition := FilePos (mpfile)-4;
        tempLongInt := Filesize(mpfile) - fFirstValidFrameHeaderPosition - data.FrameLength + (2 * Byte(data.ErrorProtection));

        If (not FrameHeaderValid(data)) or (TempLongInt <= 0) then begin
          ResetData(data);
{          Data.FileName := ExpandFileName (tempStr);}
          Data.FileLength := FileSize (mpfile);
        end else begin
          { Ok, one header is found, but that is not good proof that file realy
            is MPEG Audio. But, if we look for the next header which must be
            FrameLength bytes after first one, we may be very sure file is
            valid. }
          Seek (mpfile, fFirstValidFrameHeaderPosition + data.FrameLength);
          BlockRead (mpfile, mp3hdrread,4);
          tempbyte := mp3hdrread[1];
          mp3hdrread[1] := mp3hdrread[4];
          mp3hdrread[4] := tempbyte;
          tempbyte := mp3hdrread[2];
          mp3hdrread[2] := mp3hdrread[3];
          mp3hdrread[3] := tempbyte;
{          if mp3hdrread[1]=$0FF then bolsche:=true else bolsche:=false;
{          If not (data.bitrate<60) and not DecodeHeader (mp3hdr, Data2) then begin
            { well, next header is not valid. this is not MPEG audio file }
 {           ResetData(data);
{            Data.FileName := ExpandFileName (tempStr);
            Data.FileDateTime := FileAge (Data.fileName);}
{            Data.FileLength := FileSize (mpfile);
            { set file position back to the second byt of header that
              seemed valid tolet function read all bytes that were
              skipped inatempt tofind second header }
{            Seek (mpfile, fFirstValidFrameHeaderPosition + 1);
          end else begin
            { BINGO!!! This realy is MPEG audio file so we may proceed}
{          end; { if }
        end; { if }
      until FrameHeaderValid(data) or Eof (mpfile) or ((FilePos(mpfile) > FFileDetectionPrecision) and (FFileDetectionPrecision > 0));
     if Eof (mpfile) or ((FilePos(mpfile) > FFileDetectionPrecision) and (FFileDetectionPrecision > 0)) then result:=-1 else
      begin
       seek(mpfile,fFirstValidFrameHeaderPosition+36);
       blockread(mpfile,buffer,256);
       if (buffer[1]='X') and (buffer[2]='i') and (buffer[3]='n') and (buffer[4]='g') then
       if buffer[8]=#15 then
        begin
         data.encoder:='Audio Catalyst VBR';
         frames:=ord(buffer[9]);
         frames:=frames*256+ord(buffer[10]);
         frames:=frames*256+ord(buffer[11]);
         frames:=frames*256+ord(buffer[12]);
         data.framelength:=data.FileLength div frames;
         data.bitrate:=trunc(data.framelength*data.samplerate / 144000)- Integer (data.Padding);
         Data.Duration := (Data.FileLength*8) div (longint(Data.Bitrate)*1000);
        end;
       seek(mpfile,fFirstValidFrameHeaderPosition);
       blockread(mpfile,mp3hdrread,8);
       if mp3hdrread[4]=$04 then
        begin
         if mp3hdrread[7]=$0F then Data.encoder:='Mp3 Compressor'
          else  Data.encoder:='RadiumCodec|Xing 2.20';
        end;
       if mp3hdrread[4]=$44 then
        begin
        if mp3hdrread[8]=$00 then Data.encoder:='l3Enc'
         else
           if mp3hdrread[7]=$01 then Data.encoder:='Audioactive P. Studio'
            else Data.encoder:='mp3 Producer';
        end;
       if ((mp3hdrread[4] shr 3) and $1) = 1 then Data.encoder:='Audio Catalyst';
       if mp3hdrread[4]=$4C then Data.encoder:='Audio Catalyst VBR';
      end;
    end; { if }
    closefile(mpfile);
   end; {fileexists}
end; { FReadData }

end.
